
// Copyright (c) 2003 Sonic Foundry, Inc. and Sonic Foundry 
// Media Systems, Inc. Neither this code nor any portion 
// thereof maybe reproduced, altered,or otherwise changed, 
// distributed or copied,without the express written 
// permission of Sonic Foundry. 
// All rights reserved.

// BEGINFILE WM7PlayerArea.js -------------------------------------------------------------------------- >

WM7PlayerArea.prototype = new WM64PlayerArea();
function WM7PlayerArea(container, containingWindow, ID)
{
	this.PlayerType = PlayerType.WM7;
	
	if (container && containingWindow && ID)
	{
		this.InitializeArea(container, containingWindow, ID);
	}
	
	function WM7PlayerArea.prototype.LoadPlayerControl()
	{
		var objEmbeddedPlayer = this.GetEmbeddedPlayer();
		this.pci = new PlayerControlWM7(objEmbeddedPlayer);
	}
}

// ENDFILE WM7PlayerArea.js ----------------------------------------------------------------------------->

// BEGINFILE PlayerControlWM7.js ------------------------------------------------------------------------->
function PlayerControlWM7(objEmbeddedPlayer)
{
	this.objEmbedded=objEmbeddedPlayer;
	
	function PlayerControlWM7.prototype.GetVersionInfo()
	{
		return this.objEmbedded.versionInfo;
	}

	function PlayerControlWM7.prototype.Play()
	{
		this.objEmbedded.controls.play();
	}
	
	function PlayerControlWM7.prototype.Stop()
	{
		this.objEmbedded.controls.stop();
	}
	
	function PlayerControlWM7.prototype.Pause()
	{
		this.objEmbedded.controls.pause();
	}

	function PlayerControlWM7.prototype.GetPlayState()
	{
		return this.objEmbedded.playState;
	}
	
	function PlayerControlWM7.prototype.SetFullScreen(f)
	{
		this.objEmbedded.fullScreen = f;
	}
	
	function PlayerControlWM7.prototype.SetPosition(dPosition)
	{
		this.objEmbedded.controls.currentPosition=dPosition;
	}

	function PlayerControlWM7.prototype.GetPosition()
	{
		return this.objEmbedded.controls.currentPosition;
	}
	
	function PlayerControlWM7.prototype.GetMediaDuration()
	{
		if (this.objEmbedded.currentMedia)
		{
			return this.objEmbedded.currentMedia.duration;
		}
		
		return 0;
	}

	function PlayerControlWM7.prototype.SetMedia(sMedia)
	{
		this.objEmbedded.URL=sMedia;
	}
	
	
	function PlayerControlWM7.prototype.GetCurrentMarker()
	{
		return this.objEmbedded.controls.currentMarker;
	}
	
	function PlayerControlWM7.prototype.GetMediaMarkerCount()
	{
		if (this.objEmbedded.currentMedia)
		{
			return this.objEmbedded.currentMedia.markerCount;
		}
		
		return 0;
	}
	
	function PlayerControlWM7.prototype.GetMediaMarkerName(nIndex)
	{
		if (this.objEmbedded.currentMedia)
		{
			return this.objEmbedded.currentMedia.getMarkerName(nIndex);
		}
		
		return null;
	}
	
	function PlayerControlWM7.prototype.GetMediaMarkerTime(nIndex)
	{
		if (this.objEmbedded.currentMedia)
		{
			return this.objEmbedded.currentMedia.getMarkerTime(nIndex);
		}
		
		return 0;
	}
	
	function PlayerControlWM7.prototype.GetVolume()
	{
		return this.objEmbedded.settings.volume;
	}
	
	function PlayerControlWM7.prototype.SetVolume(nVolume)
	{
		this.objEmbedded.settings.volume=nVolume;
	}
	
	function PlayerControlWM7.prototype.SetMute(fMute)
	{
		this.objEmbedded.settings.mute=fMute;
	}
	
	function PlayerControlWM7.prototype.GetMute()
	{
		return this.objEmbedded.settings.mute;
	}
		
}

// ENDFILE PlayerControlWM7.js --------------------------------------------------------------------------->
